"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const injectedSourceUrl_1 = __importDefault(require("@secret-agent/core-interfaces/injectedSourceUrl"));
const cache = {};
const shouldCache = process.env.NODE_ENV === 'production';
const utilsScript = fs.readFileSync(`${__dirname}/utils.js`, 'utf8');
class InjectedScripts {
    constructor() {
        this.scripts = [];
    }
    build() {
        return [
            {
                // NOTE: don't make this async. It can cause issues if you read a frame right after creation, for instance
                script: `(function newDocumentScript() {
  const sourceUrl = '${injectedSourceUrl_1.default}';
  ${utilsScript}
  
   ${this.scripts.join('\n\n')}
})();
//# sourceURL=${injectedSourceUrl_1.default}`.replace(/\/\/# sourceMap.+/g, ''),
            },
        ];
    }
    add(name, args = {}) {
        let script = cache[name];
        if (!script) {
            script = fs.readFileSync(`${__dirname}/${name}.js`, 'utf8');
        }
        if (shouldCache)
            cache[name] = script;
        if (name === 'errors')
            args.sourceUrl = injectedSourceUrl_1.default;
        let wrapper = `(function newDocumentScript_${name}(args) {
  try {
    ${script};
  } catch(err) {
    console.log('Failed to initialize "${name}"', err);
  }
})(${JSON.stringify(args)});`;
        if (name === 'polyfill') {
            wrapper = `// if main frame and HTML element not loaded yet, give it a sec
  if (window.self === window.top && !document.documentElement) {
    new MutationObserver((list, observer) => {
      observer.disconnect();
      ${wrapper}
    }).observe(document, {childList: true, subtree: true});
  } else {
    ${wrapper}
  }
`;
        }
        this.scripts.push(wrapper);
    }
}
exports.default = InjectedScripts;
function getOverrideScript(name, args) {
    const injected = new InjectedScripts();
    injected.add(name, args);
    return injected.build()[0];
}
exports.getOverrideScript = getOverrideScript;
//# sourceMappingURL=index.js.map