delete Navigator.prototype.webdriver;
const props = {};
if (args.memory) {
    props.deviceMemory = { get: () => args.memory };
}
proxyDescriptors(window.navigator, props);
if (args.ensureOneVideoDevice) {
    const videoDevice = {
        deviceId: args.ensureOneVideoDevice.deviceId ||
            '34af339e7d636e6372d65f50b56e774f7cd13e127c2a48ea6d022fbdf82bed3c',
        groupId: args.ensureOneVideoDevice.groupId ||
            'cd04412d4be125b24466d2731b0eb1e30253d0c83b158e08e206e00e9e2975bb',
        kind: 'videoinput',
        label: '',
    };
    if (navigator.mediaDevices &&
        navigator.mediaDevices.enumerateDevices &&
        navigator.mediaDevices.enumerateDevices.name !== 'bound reportBlock') {
        proxyFunction(MediaDevices.prototype, 'enumerateDevices', (func, thisObj, ...args) => {
            return func.apply(thisObj, args).then(list => {
                if (list.find(x => x.kind === 'videoinput'))
                    return list;
                list.push(videoDevice);
                return list;
            });
        });
    }
}
proxyFunction(Permissions.prototype, 'query', (func, thisArg, ...parameters) => {
    if (parameters && parameters.length && parameters[0].name === 'notifications') {
        const state = Notification.permission === 'default' ? 'prompt' : Notification.permission;
        const result = { state };
        Object.setPrototypeOf(result, PermissionStatus.prototype);
        return Promise.resolve(result);
    }
    return func.apply(thisArg, parameters);
});
proxyDescriptors(Notification, {
    permission: {
        get() {
            return 'default';
        },
    },
});
//# sourceMappingURL=navigator.js.map